>From d4b57b1393721b1f0bd0dd481e41b5747f55aeca Mon Sep 17 00:00:00 2001
From: Jiri Tomasek <jtomasek@redhat.com>
Date: Thu, 21 Jun 2012 09:59:27 +0200
Subject: [PATCH 07/12] Added images required by converge-ui to images/embed/,
 changed header layout to use new logo image

---
 src/app/stylesheets/_header.scss            |    5 ++++-
 src/app/views/layouts/application.html.haml |    2 +-
 src/public/images/embed/favicon.png         |  Bin 0 -> 1525 bytes
 src/public/images/embed/logo.png            |  Bin 0 -> 3972 bytes
 src/public/images/upstream-logo.png         |  Bin 3972 -> 0 bytes
 5 files changed, 5 insertions(+), 2 deletions(-)
 create mode 100644 src/public/images/embed/favicon.png
 create mode 100644 src/public/images/embed/logo.png
 delete mode 100644 src/public/images/upstream-logo.png

diff --git a/src/app/stylesheets/_header.scss b/src/app/stylesheets/_header.scss
index a4f2bcf..58dd707 100644
--- a/src/app/stylesheets/_header.scss
+++ b/src/app/stylesheets/_header.scss
@@ -7,7 +7,10 @@
 header#header {
   height:60px;
 
-  img.upstream_logo{ margin: 20px 0px 0px 30px; }
+  .logo{
+    width: 223px;
+    bottom: 15px;
+  }
 
   #appnav {left:388px;}
 
diff --git a/src/app/views/layouts/application.html.haml b/src/app/views/layouts/application.html.haml
index ff5c7de..d9ba6b7 100644
--- a/src/app/views/layouts/application.html.haml
+++ b/src/app/views/layouts/application.html.haml
@@ -36,7 +36,7 @@
   = javascript_include_tag "lib/converge-ui/jquery/plugins/flot-0.7/excanvas.js"
 
 = content_for :logo do
-  = link_to image_tag('upstream-logo.png', :class => "upstream_logo"), root_path
+  = link_to t('layout.appname'), root_path, :class => "logo"
 
 = content_for :tabs do
   = render_navigation :level => 1
diff --git a/src/public/images/embed/favicon.png b/src/public/images/embed/favicon.png
new file mode 100644
index 0000000000000000000000000000000000000000..0da9b500af394ef1367fc6239d1b76e6d29a5969
GIT binary patch
diff --git a/src/public/images/embed/logo.png b/src/public/images/embed/logo.png
new file mode 100644
index 0000000000000000000000000000000000000000..59490125832d7454effb2475c4ee9cc20793cb66
GIT binary patch
diff --git a/src/public/images/upstream-logo.png b/src/public/images/upstream-logo.png
deleted file mode 100644
index 59490125832d7454effb2475c4ee9cc20793cb66..0000000000000000000000000000000000000000
GIT binary patch
-- 
1.7.7.6