From 05ac535e61599d9a604261ef67e7d7fd994c0ad7 Mon Sep 17 00:00:00 2001
From: "H.J. Lu" <hjl.tools@gmail.com>
Date: Wed, 25 Mar 2015 09:19:08 -0700
Subject: [PATCH 7/7] Add run-strip-test10.sh

	 * Makefile.am (TESTS): Add run-strip-test10.sh.
	 (EXTRA_DIST): Likewise.
	 * run-strip-test10.sh: New file.
	 * testfile-x32-d.bz2: Likewise.
	 * testfile-x32-debug.bz2: Likewise.

Signed-off-by: H.J. Lu <hjl.tools@gmail.com>
---
 tests/Makefile.am            |   4 ++--
 tests/run-strip-test10.sh    |  22 ++++++++++++++++++++++
 tests/testfile-x32-d.bz2     | Bin 0 -> 1725 bytes
 tests/testfile-x32-debug.bz2 | Bin 0 -> 2206 bytes
 4 files changed, 24 insertions(+), 2 deletions(-)
 create mode 100755 tests/run-strip-test10.sh
 create mode 100755 tests/testfile-x32-d.bz2
 create mode 100755 tests/testfile-x32-debug.bz2

diff --git a/tests/Makefile.am b/tests/Makefile.am
index a73623d..2f42364 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -76,7 +76,7 @@ TESTS = run-arextract.sh run-arsymtest.sh newfile test-nlist \
 	newscn run-strip-test.sh run-strip-test2.sh \
 	run-strip-test3.sh run-strip-test4.sh run-strip-test5.sh \
 	run-strip-test6.sh run-strip-test7.sh run-strip-test8.sh \
-	run-strip-test9.sh \
+	run-strip-test9.sh run-strip-test10.sh \
 	run-strip-groups.sh run-strip-reloc.sh \
 	run-unstrip-test.sh run-unstrip-test2.sh run-unstrip-M.sh \
 	run-ecp-test.sh run-ecp-test2.sh run-alldts.sh \
@@ -156,7 +156,7 @@ EXTRA_DIST = run-arextract.sh run-arsymtest.sh \
 	     run-line2addr.sh run-elflint-test.sh testfile14.bz2 \
 	     run-strip-test4.sh run-strip-test5.sh run-strip-test6.sh \
 	     run-strip-test7.sh run-strip-test8.sh run-strip-groups.sh \
-	     run-strip-test9.sh \
+	     run-strip-test9.sh run-strip-test10.sh \
 	     run-strip-reloc.sh hello_i386.ko.bz2 hello_x86_64.ko.bz2 \
 	     hello_ppc64.ko.bz2 hello_s390.ko.bz2 hello_aarch64.ko.bz2 \
 	     run-unstrip-test.sh run-unstrip-test2.sh run-unstrip-M.sh\
diff --git a/tests/run-strip-test10.sh b/tests/run-strip-test10.sh
new file mode 100755
index 0000000..a867b1b
--- /dev/null
+++ b/tests/run-strip-test10.sh
@@ -0,0 +1,22 @@
+#! /bin/sh
+# Copyright (C) H.J. Lu <hjl.tools@gmail.com>, 2015.
+# This file is part of elfutils.
+#
+# This file is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+#
+# elfutils is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+original=testfile-x32
+stripped=testfile-x32-d
+debugfile=testfile-x32-debug
+
+. $srcdir/run-strip-test.sh
diff --git a/tests/testfile-x32-d.bz2 b/tests/testfile-x32-d.bz2
new file mode 100755
index 0000000000000000000000000000000000000000..ad5836e837907aff4499fe77d32d7b3040d2416b
GIT binary patch
diff --git a/tests/testfile-x32-debug.bz2 b/tests/testfile-x32-debug.bz2
new file mode 100755
index 0000000000000000000000000000000000000000..d55a004bbf7572bd5a570ad45a8a70fec36a7971
GIT binary patch
-- 
1.9.3